| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::cuda::OpticalFlowDual_TVL1 Class Referenceabstract
CUDA-accelerated Computer Vision » Optical Flow

Implementation of the Zach, Pock and Bischof Dual TV-L1 Optical Flow method. More...

`#include <opencv2/cudaoptflow.hpp>`

Inheritance diagram for cv::cuda::OpticalFlowDual_TVL1:

## Public Member Functions
virtual double | getEpsilon () const =0
virtual double | getGamma () const =0
virtual double | getLambda () const =0
virtual int | getNumIterations () const =0
virtual int | getNumScales () const =0
virtual int | getNumWarps () const =0
virtual double | getScaleStep () const =0
virtual double | getTau () const =0
virtual double | getTheta () const =0
virtual bool | getUseInitialFlow () const =0
virtual void | setEpsilon (double epsilon)=0
virtual void | setGamma (double gamma)=0
virtual void | setLambda (double lambda)=0
virtual void | setNumIterations (int iterations)=0
virtual void | setNumScales (int nscales)=0
virtual void | setNumWarps (int warps)=0
virtual void | setScaleStep (double scaleStep)=0
virtual void | setTau (double tau)=0
virtual void | setTheta (double theta)=0
virtual void | setUseInitialFlow (bool useInitialFlow)=0
Public Member Functions inherited from cv::cuda::DenseOpticalFlow
virtual void | calc (InputArray I0, InputArray I1, InputOutputArray flow, Stream &stream=Stream::Null())=0
| Calculates a dense optical flow. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< OpticalFlowDual_TVL1 > | create (double tau=0.25, double lambda=0.15, double theta=0.3, int nscales=5, int warps=5, double epsilon=0.01, int iterations=300, double scaleStep=0.8, double gamma=0.0, bool useInitialFlow=false)
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Implementation of the Zach, Pock and Bischof Dual TV-L1 Optical Flow method.

Note
  C. Zach, T. Pock and H. Bischof, "A Duality Based Approach for Realtime TV-L1 Optical Flow".
  Javier Sanchez, Enric Meinhardt-Llopis and Gabriele Facciolo. "TV-L1 Optical Flow Estimation".

## Member Function Documentation

## ◆ create()

static Ptr<OpticalFlowDual_TVL1> cv::cuda::OpticalFlowDual_TVL1::create | ( | double | tau = `0.25`,
|  | double | lambda = `0.15`,
|  | double | theta = `0.3`,
|  | int | nscales = `5`,
|  | int | warps = `5`,
|  | double | epsilon = `0.01`,
|  | int | iterations = `300`,
|  | double | scaleStep = `0.8`,
|  | double | gamma = `0.0`,
|  | bool | useInitialFlow = `false`
| ) |  |
| static

## ◆ getEpsilon()

virtual double cv::cuda::OpticalFlowDual_TVL1::getEpsilon | ( |  | ) | const
| pure virtual

Stopping criterion threshold used in the numerical scheme, which is a trade-off between precision and running time. A small value will yield more accurate solutions at the expense of a slower convergence.

## ◆ getGamma()

virtual double cv::cuda::OpticalFlowDual_TVL1::getGamma | ( |  | ) | const
| pure virtual

Weight parameter for (u - v)^2, tightness parameter. It serves as a link between the attachment and the regularization terms. In theory, it should have a small value in order to maintain both parts in correspondence. The method is stable for a large range of values of this parameter.

## ◆ getLambda()

virtual double cv::cuda::OpticalFlowDual_TVL1::getLambda | ( |  | ) | const
| pure virtual

Weight parameter for the data term, attachment parameter. This is the most relevant parameter, which determines the smoothness of the output. The smaller this parameter is, the smoother the solutions we obtain. It depends on the range of motions of the images, so its value should be adapted to each image sequence.

## ◆ getNumIterations()

virtual int cv::cuda::OpticalFlowDual_TVL1::getNumIterations | ( |  | ) | const
| pure virtual

Stopping criterion iterations number used in the numerical scheme.

## ◆ getNumScales()

virtual int cv::cuda::OpticalFlowDual_TVL1::getNumScales | ( |  | ) | const
| pure virtual

Number of scales used to create the pyramid of images.

## ◆ getNumWarps()

virtual int cv::cuda::OpticalFlowDual_TVL1::getNumWarps | ( |  | ) | const
| pure virtual

Number of warpings per scale. Represents the number of times that I1(x+u0) and grad( I1(x+u0) ) are computed per scale. This is a parameter that assures the stability of the method. It also affects the running time, so it is a compromise between speed and accuracy.

## ◆ getScaleStep()

virtual double cv::cuda::OpticalFlowDual_TVL1::getScaleStep | ( |  | ) | const
| pure virtual

## ◆ getTau()

virtual double cv::cuda::OpticalFlowDual_TVL1::getTau | ( |  | ) | const
| pure virtual

Time step of the numerical scheme.

## ◆ getTheta()

virtual double cv::cuda::OpticalFlowDual_TVL1::getTheta | ( |  | ) | const
| pure virtual

parameter used for motion estimation. It adds a variable allowing for illumination variations Set this parameter to 1. if you have varying illumination. See: Chambolle et al, A First-Order Primal-Dual Algorithm for Convex Problems with Applications to Imaging Journal of Mathematical imaging and vision, may 2011 Vol 40 issue 1, pp 120-145

## ◆ getUseInitialFlow()

virtual bool cv::cuda::OpticalFlowDual_TVL1::getUseInitialFlow | ( |  | ) | const
| pure virtual

## ◆ setEpsilon()

virtual void cv::cuda::OpticalFlowDual_TVL1::setEpsilon | ( | double | epsilon | ) |
| pure virtual

## ◆ setGamma()

virtual void cv::cuda::OpticalFlowDual_TVL1::setGamma | ( | double | gamma | ) |
| pure virtual

## ◆ setLambda()

virtual void cv::cuda::OpticalFlowDual_TVL1::setLambda | ( | double | lambda | ) |
| pure virtual

## ◆ setNumIterations()

virtual void cv::cuda::OpticalFlowDual_TVL1::setNumIterations | ( | int | iterations | ) |
| pure virtual

## ◆ setNumScales()

virtual void cv::cuda::OpticalFlowDual_TVL1::setNumScales | ( | int | nscales | ) |
| pure virtual

## ◆ setNumWarps()

virtual void cv::cuda::OpticalFlowDual_TVL1::setNumWarps | ( | int | warps | ) |
| pure virtual

## ◆ setScaleStep()

virtual void cv::cuda::OpticalFlowDual_TVL1::setScaleStep | ( | double | scaleStep | ) |
| pure virtual

## ◆ setTau()

virtual void cv::cuda::OpticalFlowDual_TVL1::setTau | ( | double | tau | ) |
| pure virtual

## ◆ setTheta()

virtual void cv::cuda::OpticalFlowDual_TVL1::setTheta | ( | double | theta | ) |
| pure virtual

## ◆ setUseInitialFlow()

virtual void cv::cuda::OpticalFlowDual_TVL1::setUseInitialFlow | ( | bool | useInitialFlow | ) |
| pure virtual

The documentation for this class was generated from the following file:

- opencv2/cudaoptflow.hpp